<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>com.cico.nest</groupId>
    <artifactId>nest-lcdp-boot-dependencies</artifactId>
    <version>${revision}</version>
    <packaging>pom</packaging>

    <name>${project.artifactId}</name>
    <description>基础 bom 文件，管理整个项目的依赖版本</description>


    <properties>
        <revision>1.0.0</revision>
        <flatten-maven-plugin.version>1.5.0</flatten-maven-plugin.version>
        <!-- 统一依赖管理 -->
        <spring.boot.version>3.0.2</spring.boot.version>
        <!-- Test 测试相关 -->
        <podam.version>7.2.11.RELEASE</podam.version> <!-- Spring Boot 2.X 最多使用 7.2.11 版本 -->
        <jedis-mock.version>1.0.13</jedis-mock.version>
        <mockito-inline.version>4.11.0</mockito-inline.version>
        <!-- 工具类相关 -->
        <mapstruct.version>1.5.5.Final</mapstruct.version>
        <javax.mail.version>1.6.2</javax.mail.version>
        <captcha-plus.version>1.0.10</captcha-plus.version>
        <jsoup.version>1.17.2</jsoup.version>
        <lombok.version>1.18.30</lombok.version>
        <velocity.version>2.3</velocity.version>
        <screw.version>1.0.5</screw.version>
        <fastjson.version>1.2.83</fastjson.version>
        <guice.version>5.1.0</guice.version>
        <commons-net.version>3.10.0</commons-net.version>
        <jsch.version>0.1.55</jsch.version>
        <tika-core.version>2.9.1</tika-core.version>
        <bizlog-sdk.version>3.0.6</bizlog-sdk.version>
        <!-- 三方云服务相关 -->
        <okio.version>3.5.0</okio.version>
        <okhttp3.version>4.11.0</okhttp3.version>
        <commons-io.version>2.15.1</commons-io.version>
        <minio.version>8.5.7</minio.version>
        <aliyun-java-sdk-core.version>4.6.4</aliyun-java-sdk-core.version>
        <aliyun-java-sdk-dysmsapi.version>2.2.1</aliyun-java-sdk-dysmsapi.version>
        <tencentcloud-sdk-java.version>3.1.880</tencentcloud-sdk-java.version>
        <justauth.version>1.0.8</justauth.version>
        <xercesImpl.version>2.12.2</xercesImpl.version>
        <weixin-java.version>4.6.0</weixin-java.version>
        <java-jwt.version>3.12.1</java-jwt.version>
        <sa-token.version>1.38.0</sa-token.version>
    </properties>

    <dependencyManagement>
        <dependencies>
            <!-- springboot 统一依赖管理 -->
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-dependencies</artifactId>
                <version>${spring.boot.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <!--core -->
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-core-system</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-core-infra</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-core-sso</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-core-qxsd</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-framework-form-starter</artifactId>
                <version>${revision}</version>
            </dependency>
            <!-- common-->
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-common</artifactId>
                <version>${revision}</version>
            </dependency>
            <!-- api -->
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-api-system</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-api-infra</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-framework-api</artifactId>
                <version>1.0.1</version>
            </dependency>
            <!-- starters -->
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-web-starter</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-test-starter</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-security-starter</artifactId>
                <version>${revision}</version>
            </dependency>
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-tenant-starter</artifactId>
                <version>${revision}</version>
            </dependency>

            <!-- server -->
            <dependency>
                <groupId>com.cico.nest</groupId>
                <artifactId>nest-lcdp-boot-server</artifactId>
                <version>${revision}</version>
            </dependency>

            <!-- mapstruct -->
            <dependency>
                <groupId>org.mapstruct</groupId>
                <artifactId>mapstruct</artifactId> <!-- use mapstruct-jdk8 for Java 8 or higher -->
                <version>${mapstruct.version}</version>
            </dependency>
            <dependency>
                <groupId>org.mapstruct</groupId>
                <artifactId>mapstruct-jdk8</artifactId>
                <version>${mapstruct.version}</version>
            </dependency>
            <dependency>
                <groupId>org.mapstruct</groupId>
                <artifactId>mapstruct-processor</artifactId>
                <version>${mapstruct.version}</version>
            </dependency>
            <!-- 邮箱 -->
            <dependency>
                <groupId>com.sun.mail</groupId>
                <artifactId>javax.mail</artifactId>
                <version>${javax.mail.version}</version>
            </dependency>
            <!-- lombok -->
            <dependency>
                <groupId>org.projectlombok</groupId>
                <artifactId>lombok</artifactId>
                <version>${lombok.version}</version>
            </dependency>
            <!-- jsoup -->
            <dependency>
                <groupId>org.jsoup</groupId>
                <artifactId>jsoup</artifactId>
                <version>${jsoup.version}</version>
            </dependency>
            <!-- 测试相关 -->
            <dependency>
                <groupId>org.mockito</groupId>
                <artifactId>mockito-inline</artifactId>
                <version>${mockito-inline.version}</version> <!-- 支持 Mockito 的 final 类与 static 方法的 mock -->
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-test</artifactId>
                <version>${spring.boot.version}</version>
                <exclusions>
                    <exclusion>
                        <artifactId>asm</artifactId>
                        <groupId>org.ow2.asm</groupId>
                    </exclusion>
                    <exclusion>
                        <groupId>org.mockito</groupId>
                        <artifactId>mockito-core</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>com.github.fppt</groupId> <!-- 单元测试，我们采用内嵌的 Redis 数据库 -->
                <artifactId>jedis-mock</artifactId>
                <version>${jedis-mock.version}</version>
            </dependency>
            <dependency>
                <groupId>uk.co.jemos.podam</groupId> <!-- 单元测试，随机生成 POJO 类 -->
                <artifactId>podam</artifactId>
                <version>${podam.version}</version>
            </dependency>
            <!-- bizlog-sdk -->
            <dependency>
                <groupId>io.github.mouzt</groupId>
                <artifactId>bizlog-sdk</artifactId>
                <version>${bizlog-sdk.version}</version>
                <exclusions>
                    <exclusion> <!-- 排除掉springboot依赖使用项目的 -->
                        <groupId>org.springframework.boot</groupId>
                        <artifactId>spring-boot-starter</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <!-- velocity -->
            <dependency>
                <groupId>org.apache.velocity</groupId>
                <artifactId>velocity-engine-core</artifactId>
                <version>${velocity.version}</version>
            </dependency>
            <!-- screw -->
            <dependency>
                <groupId>cn.smallbun.screw</groupId>
                <artifactId>screw-core</artifactId> <!-- 实现数据库文档 -->
                <version>${screw.version}</version>
                <exclusions>
                    <exclusion>
                        <groupId>org.freemarker</groupId>
                        <artifactId>freemarker</artifactId> <!-- 移除 Freemarker 依赖，采用 Velocity 作为模板引擎 -->
                    </exclusion>
                    <exclusion>
                        <groupId>com.alibaba</groupId>
                        <artifactId>fastjson</artifactId> <!-- 最新版screw-core1.0.5依赖fastjson1.2.73存在漏洞，移除。 -->
                    </exclusion>
                </exclusions>
            </dependency>
            <!-- 第三方云服务 -->
            <dependency>
                <groupId>commons-net</groupId>
                <artifactId>commons-net</artifactId> <!-- 解决 ftp 连接 -->
                <version>${commons-net.version}</version>
            </dependency>
            <dependency>
                <groupId>com.jcraft</groupId>
                <artifactId>jsch</artifactId> <!-- 解决 sftp 连接 -->
                <version>${jsch.version}</version>
            </dependency>
            <dependency>
                <groupId>io.minio</groupId>
                <artifactId>minio</artifactId>
                <version>${minio.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.tika</groupId>
                <artifactId>tika-core</artifactId> <!-- 文件类型的识别 -->
                <version>${tika-core.version}</version>
            </dependency>
            <dependency>
                <groupId>com.xingyuv</groupId>
                <artifactId>spring-boot-starter-justauth</artifactId> <!-- 社交登陆（例如说，个人微信、企业微信等等） -->
                <version>${justauth.version}</version>
                <exclusions>
                    <exclusion>
                        <groupId>cn.hutool</groupId>
                        <artifactId>hutool-core</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>com.github.binarywang</groupId>
                <artifactId>wx-java-mp-spring-boot-starter</artifactId>
                <version>${weixin-java.version}</version>
            </dependency>
            <dependency>
                <groupId>com.github.binarywang</groupId>
                <artifactId>wx-java-miniapp-spring-boot-starter</artifactId>
                <version>${weixin-java.version}</version>
            </dependency>
            <!-- SMS SDK begin -->
            <dependency>
                <groupId>com.aliyun</groupId>
                <artifactId>aliyun-java-sdk-core</artifactId>
                <version>${aliyun-java-sdk-core.version}</version>
                <exclusions>
                    <exclusion>
                        <artifactId>opentracing-api</artifactId>
                        <groupId>io.opentracing</groupId>
                    </exclusion>
                    <exclusion>
                        <artifactId>opentracing-util</artifactId>
                        <groupId>io.opentracing</groupId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>com.aliyun</groupId>
                <artifactId>aliyun-java-sdk-dysmsapi</artifactId>
                <version>${aliyun-java-sdk-dysmsapi.version}</version>
            </dependency>
            <dependency>
                <groupId>com.tencentcloudapi</groupId>
                <artifactId>tencentcloud-sdk-java-sms</artifactId>
                <version>${tencentcloud-sdk-java.version}</version>
            </dependency>
            <!-- SMS SDK end -->
            <dependency>
                <groupId>com.xingyuv</groupId>
                <artifactId>spring-boot-starter-captcha-plus</artifactId>
                <version>${captcha-plus.version}</version> <!-- 验证码，一般用于登录使用 -->
            </dependency>
            <dependency>
                <groupId>com.auth0</groupId>
                <artifactId>java-jwt</artifactId>
                <version>${java-jwt.version}</version>
            </dependency>

            <!-- Sa-Token -->
            <dependency>
                <groupId>cn.dev33</groupId>
                <artifactId>sa-token-spring-boot3-starter</artifactId>
                <version>${sa-token.version}</version>
            </dependency>
            <!-- Sa-Token 插件：整合SSO -->
            <dependency>
                <groupId>cn.dev33</groupId>
                <artifactId>sa-token-sso</artifactId>
                <version>${sa-token.version}</version>
            </dependency>
            <!-- Sa-Token 插件：整合redis (使用jackson序列化方式) -->
            <dependency>
                <groupId>cn.dev33</groupId>
                <artifactId>sa-token-redis-jackson</artifactId>
                <version>${sa-token.version}</version>
            </dependency>
            <!-- Sa-Token插件：权限缓存与业务缓存分离 -->
            <dependency>
                <groupId>cn.dev33</groupId>
                <artifactId>sa-token-alone-redis</artifactId>
                <version>${sa-token.version}</version>
            </dependency>
            <!-- Http请求工具 -->
            <dependency>
                <groupId>com.dtflys.forest</groupId>
                <artifactId>forest-spring-boot-starter</artifactId>
                <version>1.5.26</version>
            </dependency>
        </dependencies>
    </dependencyManagement>
    <build>
        <plugins>
            <!-- 统一 revision 版本 -->
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>flatten-maven-plugin</artifactId>
                <version>${flatten-maven-plugin.version}</version>
                <configuration>
                    <flattenMode>resolveCiFriendliesOnly</flattenMode>
                    <updatePomFile>true</updatePomFile>
                </configuration>
                <executions>
                    <execution>
                        <goals>
                            <goal>flatten</goal>
                        </goals>
                        <id>flatten</id>
                        <phase>process-resources</phase>
                    </execution>
                    <execution>
                        <goals>
                            <goal>clean</goal>
                        </goals>
                        <id>flatten.clean</id>
                        <phase>clean</phase>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>

</project>
